Bug 122707 - Writer: Print (selected) pages harder to use in new printer dialog in 6.3+
Summary: Writer: Print (selected) pages harder to use in new printer dialog in 6.3+
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
6.3.0.0.alpha0+
Hardware: All All
: medium normal
Assignee: Heiko Tietze
URL:
Whiteboard: target:6.3.0
Keywords:
Depends on:
Blocks: Print-Dialog
  Show dependency treegraph
 
Reported: 2019-01-14 15:17 UTC by Timur
Modified: 2019-03-28 21:23 UTC (History)
8 users (show)

See Also:
Crash report or crash signature:


Attachments
Ranges and Copies - compare LO 6.2 6.3+.jpg (74.42 KB, image/jpeg)
2019-01-14 15:17 UTC, Timur
Details
New dialog (215.47 KB, image/png)
2019-03-05 14:22 UTC, Heiko Tietze
Details
alternative suggestion for a part of the dlg (25.15 KB, image/png)
2019-03-15 14:54 UTC, Cor Nouws
Details
Dialog in Glade showing the basic layout (59.75 KB, image/png)
2019-03-18 11:38 UTC, Heiko Tietze
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Timur 2019-01-14 15:17:10 UTC
Created attachment 148308 [details]
Ranges and Copies - compare LO 6.2 6.3+.jpg

Writer has new printer dialog from 6.3+.
Print (selected) pages is harder to use in new printer dialog in 6.3+
Previously, "Pages" to select was visible, although one had to select first to write pages. 
Now, "Print pages" is not visible, which I find a step backwards.

Since there seems to be enough space, I don't know why there's dropdown for: 
Print all pages,
Print pages,
Print even pages,
Print odd pages.
IMHO, radio would be better. 

Also, click on pages number field should select "Print pages" option, so that we save a click.
Comment 1 V Stuart Foote 2019-01-14 17:45:31 UTC
OK, had to think a bit on this. So your concern is use of listbox rather than radio button selectors.

Have to admit that given the larger fixed size of the dialog (seems it could be resizable) that adding the two additional Radio buttons (for Print Even, Print Odd) might be better UX.
Comment 2 Heiko Tietze 2019-01-15 09:03:44 UTC
The decision was made by the devs to save space. Talked to him about this during last year's conference. Not sure how much time Daniel is willing to put into the project after GSoC.
Comment 3 Daniel Silva 2019-01-23 22:59:17 UTC
(In reply to Timur from comment #0)
> Since there seems to be enough space, I don't know why there's dropdown for: 
> Print all pages,
> Print pages,
> Print even pages,
> Print odd pages.
> IMHO, radio would be better.

There seems to be extra space available, but that space is reserved for custom options of N-Up configuration that are hidden by default. Under "Pages per sheet", select "Custom" option and those extra options will show up.

(In reply to Heiko Tietze from comment #2)
> The decision was made by the devs to save space. Talked to him about this
> during last year's conference. Not sure how much time Daniel is willing to
> put into the project after GSoC.

I think I am not in a position to make promises that I will have plenty of time to still work in the print dialog, but I would like to continue contributing whenever I can.
Comment 4 Heiko Tietze 2019-03-05 14:22:00 UTC
Created attachment 149741 [details]
New dialog

That's how the dialog would look like in Writer. Comments are welcome.
Comment 5 Roman Kuznetsov 2019-03-05 18:55:44 UTC
(In reply to Heiko Tietze from comment #4)
> Created attachment 149741 [details]
> New dialog
> 
> That's how the dialog would look like in Writer. Comments are welcome.

field "Pages" too long, why?
bad idea to use vertical and horizontal scrollbars in this dialog
different vertical alignment of drop-down lists in top part of dialog and bottom part

and current ui file is very hard, I mean structure of containers. IMHO it needs to make ONE grid for all controls on tab General and rewrite .cxx
Comment 6 Heiko Tietze 2019-03-06 10:30:09 UTC
(In reply to Roman Kuznetsov from comment #5)
> field "Pages" too long, why?

It spawns over two columns, could make it half of the size. But why? Users enter page numbers there, potentially long like "1,3-5,7,9,13,122,125-187,200"

> bad idea to use vertical and horizontal scrollbars in this dialog

Scrollbars show up automatically (after setting pages per sheet to custom as Daniel commented); I cannot give more vertical room to prevent the horizontal scrollbar but users can resize the dialog.

> different vertical alignment of drop-down lists in top part of dialog and
> bottom part

Didn't touch the lower part. And we cannot have a grid that spawns over frames nor it's (easily) possible to define a common width. But yes, also thought about a solution here.

> and current ui file is very hard, I mean structure of containers. IMHO it
> needs to make ONE grid for all controls on tab General and rewrite .cxx

I changed the frame content to a simple 3x10 grid.


The question is more if we really want to have that many radio buttons. The dropdown has an advantage. (I vote for radio buttons)
Comment 7 Regina Henschel 2019-03-07 12:16:39 UTC
'Even pages' and 'Odd pages' is no alternative to 'Pages' and 'Selection'. But it is used parallel in case of manual duplex. Please compare with print dialog in Acrobat Reader.

Many print dialogs have an option 'current page'. It is missing here.

The field 'Pages:' needs an information, which delimiter is allowed. It might be comma, semicolon or both. Where is this information given?

In case of mixed orientated content (e.g. envelop + Din A4 portrait letter + Din A4 landscape table appendix), who is responsible for selecting the orientation and the paper tray. Making a brochure has the same problem of responsibility. How can the dialog help the user to make the suitable settings for his specific printer?

What items are contained in field 'Paper size'? What selection is correct for the 'envelop + letter' case? 

Which settings of the dialog can be stored in the document and be reloaded? Which settings of the dialog are persistent in a session? What are the default settings of the dialog, can the user customize the defaults?

I think, that the dialog is too high.

BTW: Do you know the former OpenOffice project "Printer Pull Pages"? https://wiki.openoffice.org/wiki/Printerpullpages
Comment 8 Heiko Tietze 2019-03-07 12:22:18 UTC
(In reply to Regina Henschel from comment #7)
> 'Even pages' and 'Odd pages' is no alternative to 'Pages' and 'Selection'.

I haven't changed the logic. Even pages are #2,#4,#6 etc. All printer relevant settings such as duplex or not are below.
 
> Many print dialogs have an option 'current page'. It is missing here.

The current page is included in the selection (Page: or Slide:).
 
> The field 'Pages:' needs an information, which delimiter is allowed. It
> might be comma, semicolon or both. Where is this information given?

The inline tip is shown when the field is empty. Haven't touched it.
 
> In case of mixed orientated content (e.g. envelop + Din A4 portrait letter +
> Din A4 landscape table appendix), who is responsible for selecting the
> orientation and the paper tray. 
> ...
> What items are contained in field 'Paper size'? What selection is correct
> for the 'envelop + letter' case? 

Sorry, I cannot answer these question too.

> I think, that the dialog is too high.

We could somehow make it smaller and have always a scrollbar (which is what I changed). But IMHO we can keep it like this.

Patch is btw at https://gerrit.libreoffice.org/#/c/68846/
Comment 9 Regina Henschel 2019-03-07 14:27:01 UTC
(In reply to Heiko Tietze from comment #8)
> (In reply to Regina Henschel from comment #7)
> > 'Even pages' and 'Odd pages' is no alternative to 'Pages' and 'Selection'.
> 
> I haven't changed the logic. Even pages are #2,#4,#6 etc. All printer
> relevant settings such as duplex or not are below.

But they are radio buttons of the same group. So only one of them can be selected. So setting "selection, only even" is not possible, for example. It was possible in the old dialog.
Comment 10 Heiko Tietze 2019-03-07 15:40:12 UTC
(In reply to Regina Henschel from comment #9)
> So setting "selection, only even" is not possible, for example. 

Not sure that it makes sense (in Calc it is still possible since this module tweaks the dialog strangly). My patch moves the items out of the combobox into radiobuttons.
Comment 11 Regina Henschel 2019-03-07 17:30:55 UTC
(In reply to Heiko Tietze from comment #10)
> (In reply to Regina Henschel from comment #9)
> > So setting "selection, only even" is not possible, for example. 
> 
> Not sure that it makes sense (in Calc it is still possible since this module
> tweaks the dialog strangly). My patch moves the items out of the combobox
> into radiobuttons.

Use case: Print a chapter from a larger book in manual duplex.
How to: Set pages to e.g. 35-60. Select 'even pages'. Print. Turn printed paper. Select 'odd pages'. Print. Depending on your printer, you need 'in revers order' in addition either on even or on odd pages.
Comment 12 Commit Notification 2019-03-14 15:04:09 UTC
heiko tietze committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/044fa501e95dcac8120767996dfb7ba8f25a703f%5E%21

Resolves tdf#122707 - Replace listbox for print range by radio buttons

It will be available in 6.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 13 Heiko Tietze 2019-03-14 15:10:06 UTC
Fixed, please verify on the various modules.
Comment 14 Cor Nouws 2019-03-15 14:54:46 UTC
Created attachment 149999 [details]
alternative suggestion for a part of the dlg


(In reply to Regina Henschel from comment #11)

> Use case: Print a chapter from a larger book in manual duplex.
> How to: Set pages to e.g. 35-60. Select 'even pages'. Print. Turn printed
> paper. Select 'odd pages'. Print. Depending on your printer, you need 'in
> revers order' in addition either on even or on odd pages.
Indeed, that is something that we can do better.

Attached a little suggestion, both fixing the problem and saving vertical space.
That eats width of the field for the pages, but I think that's a small price for the gains.

I tested on Version: 6.3.0.0.alpha0+
Build ID: bbf9b65f91e8136fa1a2e17960944b8720f5d58e
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
Locale: nl-NL (nl_NL.UTF-8); UI-Language: en-US
Calc: threaded
Comment 15 Heiko Tietze 2019-03-18 11:38:26 UTC
Created attachment 150044 [details]
Dialog in Glade showing the basic layout

(In reply to Cor Nouws from comment #14)
> Attached a little suggestion, both fixing the problem and saving vertical
> space.

Good idea. But we have 5 entries: All Pages, Pages:, Even, Odd, Selection. It depends on the module what is shown. So Selection is hidden in Calc (the selection is done in extra controls), and the text changes for Impress/Draw. What we could do is to move Odd right of Even but due to the three column layout it wouldn't look nice. And actually all options are mutually exclusive.
Comment 16 Cor Nouws 2019-03-18 16:02:10 UTC
(In reply to Heiko Tietze from comment #15)
> And actually all options are mutually exclusive.
As explained, in the current situation the combination of Selection with Od or Even is missing.